#ifndef GROUNDITEMS_HPP_INCLUDED
#define GROUNDITEMS_HPP_INCLUDED

#include "../../Game/Interactable/GroundItem.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

/** @addtogroup Models
* @{ */
class GroundItems
{
    public:

        static std::vector<Interactable::GroundItem> GetAllWithin(std::int32_t Distance);

        static std::vector<Interactable::GroundItem> GetAll();
        static std::vector<Interactable::GroundItem> GetAll(const Tile& T);
        static std::vector<Interactable::GroundItem> GetAll(std::int32_t ID, std::int32_t Distance = -1);
        static std::vector<Interactable::GroundItem> GetAll(const std::string& Name, std::int32_t Distance = -1);
        static std::vector<Interactable::GroundItem> GetAll(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
        static std::vector<Interactable::GroundItem> GetAll(const std::vector<std::string>& Names, std::int32_t Distance = -1);
        static std::vector<Interactable::GroundItem> GetAll(const std::function<bool (Interactable::GroundItem&)>& Filter, std::int32_t Distance = -1);

        static Interactable::GroundItem Get(const Tile& T);
        static Interactable::GroundItem Get(std::int32_t ID, std::int32_t Distance = -1);
        static Interactable::GroundItem Get(const std::string& Name, std::int32_t Distance = -1);
        static Interactable::GroundItem Get(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
        static Interactable::GroundItem Get(const std::vector<std::string>& Names, std::int32_t Distance = -1);
        static Interactable::GroundItem Get(const std::function<bool (Interactable::GroundItem&)>& Filter, std::int32_t Distance = -1);
};
/** @} */

#endif // GROUNDITEMS_HPP_INCLUDED
